Subject: Doctrine proxy class files can't be overwritten by other SAPI type
Description

When you run FLOW3 with empty caches for example from the command line, Doctrine proxy classes will be created. However, these
files can't be overwritten or trashed by FLOW3 when it's running in web mode because the files are created with read-only
permissions for the group. The same happens vice versa (first hit with Web).

The solution would be to create Doctrine proxy files with -rw-rw-r-- permissions.

Associated revisions
Revision 30151e02 - 2011-04-12 14:39 - Karsten Dambekalns

[TASK] Use temporary file and rename for proxy class creation

Instead of a simple file_put_contents() the proxy class code is written
to a temporary file and renamed to the final filename. This allows file
access even if only allowed by the directory permission.

Fixes: #25776
Change-Id: Icec4e1a7ecebf96cf07a9be09f3c9510b0679f63

History
#1 - 2011-04-05 18:32 - Karsten Dambekalns
- Status changed from New to Accepted

#2 - 2011-04-07 08:16 - Karsten Dambekalns

For reference, this is what we use, the trick is the umask in combination with our recommended permissions (sticky group bit):
if (!is_dir($path) && strlen($path) > 0) {
            $oldMask = umask(000);
            mkdir($path, 0777, TRUE);
            umask($oldMask);
            if (!is_dir($path)) throw new \F3\FLOW3\Utility\Exception('Could not create directory "' . $path . '"!', 1170251400);
        }

#3 - 2011-04-11 18:06 - Karsten Dambekalns

No, it's a more general problem. All files, also the cache files FLOW3 creates, are not writeable by the group, thus the problem exists for those as well.
#4 - 2011-04-12 14:39 - Mr. Hudson

Patch set 1 of change Icec4e1a7ecebf96cf07a9be09f3c9510b0679f63 has been pushed to the review server.
It is available at http://review.typo3.org/1580

#5 - 2011-04-12 14:39 - Karsten Dambekalns
- Status changed from Accepted to Under Review

#6 - 2011-04-12 14:41 - Karsten Dambekalns

Karsten Dambekalns wrote:

All files, also the cache files FLOW3 creates, are not writeable by the group, thus the problem exists for those as well.

Turns out that this is true, but still the cache files can be replaced, because we use rename to move a temporary file in place of the old file. The
DOctrine ProxyFactory does not do this.

#7 - 2011-04-13 11:00 - Karsten Dambekalns
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:30151e02cd9cc893af94dcf4852ace3ee17f8e0b.
